/*
LN^f[^`pe[u

	fBXNԍ
	ʂZN^ԍiwb_j
	ZN^iwb_j
	ʂZN^ԍif[^j0x6000`Ƀ[h
	ZN^if[^j
	ǂݏoif[^j+0x6500Ƀ[h

	DISK-B  49D 02  4A9 01 0000  4AA 09 0011  4B3 0F 08A2  4C2 05 176F
	DISK-B  49F 05  4A9 01 0000  4C7 19 0011  4F1 0F 184C  4E0 11 268E
	DISK-B  4A4 05  4A9 01 0000  4C7 19 0011  4AA 09 184C  4B3 0F 20DD

	DISK-C  46F 04  48B 03 0000  49E 06 02A8  4B9 09 0866  4C2 10 10AE
	DISK-C  473 02  48B 03 0000  49E 06 02A8  4B9 09 0866  3B4 07 10AE
	DISK-C  478 03  48B 03 0000  49E 06 02A8  4A4 15 0866  4E9 07 1CA9
	DISK-C  47B 03  48B 03 0000  49E 06 02A8  4A4 15 0866  48E 10 1CA9
	DISK-C  475 03  48B 03 0000  48E 10 02A8  4A4 15 121E  4E2 07 2661
	DISK-C  47E 03  48B 03 0000  48E 10 02A8  4A4 15 121E  4F0 04 2661
	DISK-C  481 03  48B 03 0000  48E 10 02A8  4A4 15 121E  4F4 0C 2661
	DISK-C  487 04  48B 03 0000  48E 10 02A8  4A4 15 121E  4D2 10 2661
	DISK-C  484 03  48B 03 0000  48E 10 02A8  4F4 0C 121E  4E2 07 1DB5

	DISK-D  486 04  494 01 0000  495 09 0011  49E 21 08A2  4BF 13 291F
	DISK-D  48A 04  494 01 0000  495 09 0011  49E 21 08A2  4EE 09 291F
	DISK-D  48E 03  494 01 0000  495 09 0011  4D2 0D 08A2  4F7 09 14CE
	DISK-D  491 03  494 01 0000  495 09 0011  4D2 0D 08A2  4DF 0F 14CE

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXBUFF		0x16000

void	convpic(int c_patdat[16][8],int patdat[16][8]);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		patinf[3][12*2] = {
		{
			0x04a9 - 0x04a9, 0x01,
			0x04aa - 0x04a9, 0x09,
			0x04b3 - 0x04a9, 0x0f,
			0x04c2 - 0x04a9, 0x05,
			0x04c7 - 0x04a9, 0x19,
			0x04e0 - 0x04a9, 0x11,
			0x04f1 - 0x04a9, 0x0f,
			-1,-1,
			-1,-1,
			-1,-1,
			-1,-1,
			-1,-1
		},{
			0x03b4 - 0x03b4, 0x07,
			0x048b - 0x03b4, 0x03,
			0x048e - 0x03b4, 0x10,
			0x049e - 0x03b4, 0x06,
			0x04a4 - 0x03b4, 0x15,
			0x04b9 - 0x03b4, 0x09,
			0x04c2 - 0x03b4, 0x10,
			0x04d2 - 0x03b4, 0x10,
			0x04e9 - 0x03b4, 0x07,
			0x04f0 - 0x03b4, 0x04,
			0x04f4 - 0x03b4, 0x0c,
			-1,-1
		},{
			0x0494 - 0x0494, 0x01,
			0x0495 - 0x0494, 0x09,
			0x049e - 0x0494, 0x21,
			0x04bf - 0x0494, 0x13,
			0x04d2 - 0x0494, 0x0d,
			0x04df - 0x0494, 0x0f,
			0x04ee - 0x0494, 0x09,
			0x04f7 - 0x0494, 0x09,
			-1,-1,
			-1,-1,
			-1,-1,
			-1,-1
		}
	};

	int		chrpixel[16][8];
	int		c_chrpixel[16][8];

	int		buff[MAXBUFF];

	int		width,height;
	int		x,y;
	int		m,n,i,j,k;
	int		col,colct,cb;
	int		a0,a1,a2,a3,c;
	int		sft;
	int		fileno;
	int		offset,size;
	int		ptr,dtpos;
	int		filelen;

	if (argc != 4) {
		fprintf(stderr, "Usage: convchara infile outfile number\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	fileno = atoi(argv[3]) - 1;

	i = 0;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	filelen = i;


	for (i = 0;i < 12;i ++) {

		offset = patinf[fileno][i*2] * 0x100;
		size   = patinf[fileno][i*2+1] * 0x100;
		if (offset == -1) {
			break;
		}
		fseek(infp,offset,SEEK_SET);
		ptr = 0;

		for (;;) {

			for (y = 0;y < 8;y ++) {
				for (x = 0;x < 16;x ++) {
					chrpixel[x][y] = 0x08;
				}
			}

			dtpos = offset + ptr;
			cb = fgetc(infp); ptr ++;

			if (ptr >= size) {
				break;
			} else if (cb >= 0x08) {
				break;
			} else if ( (cb == 0x00) && (ptr+0x30) > size) {
				break;
			} else if ( (cb != 0x00) && (ptr+0x10) > size) {
				break;
			} else {

				if (cb == 0x00) {
					col = 0x01;
					colct = 3;
				} else {
					col = cb;
					colct = 1;
				}

				for (j = 0;j < colct;j ++ ) {
					for (y = 0;y < 8;y ++) {

						c = fgetc(infp); ptr ++;
						sft = 0x80;
						for (x = 0;x < 8;x ++) {
							if ((sft & c) != 0) {
								chrpixel[x][y] |= col;
							}
							sft /= 2;
						}

						c = fgetc(infp); ptr ++;
						sft = 0x80;
						for (x = 8;x < 16;x ++) {
							if ((sft & c) != 0) {
								chrpixel[x][y] |= col;
							}
							sft /= 2;
						}

					}
					col *= 2;
				}

			}

/* hbgԈ */
			convpic(c_chrpixel,chrpixel);

/* t@Cɔf */

			if (cb == 0x00) {

				for (y = 0;y < 8;y ++) {
					buff[dtpos+1+y*6+0] = c_chrpixel[ 0][y];
					buff[dtpos+1+y*6+1] = c_chrpixel[ 2][y];
					buff[dtpos+1+y*6+2] = c_chrpixel[ 4][y] | (c_chrpixel[ 6][y] << 4);
					buff[dtpos+1+y*6+3] = c_chrpixel[ 8][y];
					buff[dtpos+1+y*6+4] = c_chrpixel[10][y];
					buff[dtpos+1+y*6+5] = c_chrpixel[12][y] | (c_chrpixel[14][y] << 4);
				}

			} else {

				for (y = 0;y < 8;y ++) {
					buff[dtpos+1+y] =
							( (c_chrpixel[ 0][y] != 0x08) ? 0x80 : 0x00) + 
							( (c_chrpixel[ 2][y] != 0x08) ? 0x40 : 0x00) + 
							( (c_chrpixel[ 4][y] != 0x08) ? 0x20 : 0x00) + 
							( (c_chrpixel[ 6][y] != 0x08) ? 0x10 : 0x00) + 
							( (c_chrpixel[ 8][y] != 0x08) ? 0x08 : 0x00) + 
							( (c_chrpixel[10][y] != 0x08) ? 0x04 : 0x00) + 
							( (c_chrpixel[12][y] != 0x08) ? 0x02 : 0x00) + 
							( (c_chrpixel[14][y] != 0x08) ? 0x01 : 0x00);
				}
				for (y = 0;y < 8;y ++) {
					buff[dtpos+1+y+8] = 0x00;
				}

			}

		}
	}

	for (i = 0;i < filelen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}




void	convpic(int c_patdat[16][8],int patdat[16][8])
{
	int		x,y,yt;
	int		tmppat[8][8];
	int		a00,a01,a02,a03,a04,a05,a06,a07;
	int		a08,a09,a10,a11,a12,a13,a14,a15;

/* hbgԈ */
	for (y = 0;y < 8;y ++) {

		a00 = patdat[ 0][y];
		a01 = patdat[ 1][y];
		a02 = patdat[ 2][y];
		a03 = patdat[ 3][y];
		a04 = patdat[ 4][y];
		a05 = patdat[ 5][y];
		a06 = patdat[ 6][y];
		a07 = patdat[ 7][y];
		a08 = patdat[ 8][y];
		a09 = patdat[ 9][y];
		a10 = patdat[10][y];
		a11 = patdat[11][y];
		a12 = patdat[12][y];
		a13 = patdat[13][y];
		a14 = patdat[14][y];
		a15 = patdat[15][y];

		c_patdat[0][y] = a00;
		c_patdat[1][y] = a02;
		c_patdat[2][y] = a04;
		c_patdat[3][y] = a06;
		c_patdat[4][y] = a08;
		c_patdat[5][y] = a10;
		c_patdat[6][y] = a12;
		c_patdat[7][y] = a14;


		yt = 0;

		if (a00 == a02 && a01 == a03) {
			if ( (yt%2) == 0) {
				c_patdat[0][y] = a00;
				c_patdat[1][y] = a01;
			} else {
				c_patdat[0][y] = a01;
				c_patdat[1][y] = a00;
			}
		}

		if (a02 == a04 && a03 == a05) {
			if ( (yt%2) == 0) {
				c_patdat[2][y] = a02;
				c_patdat[1][y] = a03;
			} else {
				c_patdat[2][y] = a03;
				c_patdat[1][y] = a02;
			}
		}

		if (a04 == a06 && a05 == a07) {
			if ( (yt%2) == 0) {
				c_patdat[2][y] = a04;
				c_patdat[3][y] = a05;
			} else {
				c_patdat[2][y] = a05;
				c_patdat[3][y] = a04;
			}
		}

		if (a06 == a08 && a07 == a09) {
			if ( (yt%2) == 0) {
				c_patdat[4][y] = a06;
				c_patdat[3][y] = a07;
			} else {
				c_patdat[4][y] = a07;
				c_patdat[3][y] = a06;
			}
		}

		if (a08 == a10 && a09 == a11) {
			if ( (yt%2) == 0) {
				c_patdat[4][y] = a08;
				c_patdat[5][y] = a09;
			} else {
				c_patdat[4][y] = a09;
				c_patdat[5][y] = a08;
			}
		}

		if (a10 == a12 && a11 == a13) {
			if ( (yt%2) == 0) {
				c_patdat[6][y] = a10;
				c_patdat[5][y] = a11;
			} else {
				c_patdat[6][y] = a11;
				c_patdat[5][y] = a10;
			}
		}

		if (a12 == a14 && a13 == a15) {
			if ( (yt%2) == 0) {
				c_patdat[6][y] = a12;
				c_patdat[7][y] = a13;
			} else {
				c_patdat[6][y] = a13;
				c_patdat[7][y] = a12;
			}
		}

	}


	for (y = 0;y < 8;y ++) {
		for (x = 0;x < 8;x ++) {
			tmppat[x][y] = c_patdat[x][y];
		}
	}

	for (y = 0;y < 8;y ++) {
		for (x = 0;x < 16;x ++) {
			c_patdat[x][y] = tmppat[x/2][y];
		}
	}

	return;

}

